- Qt 6.9
- Qt Wayland Compositor
- QML Types
- QtWayland.Compositor.WlShell
- WlShellSurface
- Qt Wayland Compositor | Commercial or GPLv3

# WlShellSurface QML Type

Provides a `wl_shell_surface` that offers desktop-style compositor-specific features to a surface. More...

Import Statement: | `import QtWayland.Compositor.WlShell`
In C++: | QWaylandWlShellSurface

- List of all members, including inherited members

## Properties

- className : string
- shell : WlShell
- surface : WaylandSurface
- title : string
- windowType : enum

## Methods

- void initialize(WlShell shell, WaylandSurface surface, WaylandResource resource)
- void ping()
- void sendConfigure(size s, enum edges)
- void sendPopupDone()

## Detailed Description

This type is part of the WlShell extension and provides a way to extend the functionality of an existing WaylandSurface with features specific to desktop-style compositors, such as resizing and moving the surface.

It corresponds to the Wayland interface `wl_shell_surface`.

## Property Documentation

className : string `[read-only]`

This property holds the class name of the WlShellSurface.

shell : WlShell `[read-only]`

This property holds the shell associated with this WlShellSurface.

surface : WaylandSurface `[read-only]`

This property holds the `wl_surface` associated with this WlShellSurface.

title : string `[read-only]`

This property holds the title of the WlShellSurface.

windowType : enum `[read-only]`

This property holds the window type of the WlShellSurface.

## Method Documentation

void initialize(WlShell shell, WaylandSurface surface, WaylandResource resource)

Initializes the WlShellSurface and associates it with the given shell, surface, and resource.

void ping()

Sends a ping event to the client. If the client replies to the event the pong signal will be emitted.

void sendConfigure(size s, enum edges)

Sends a configure event to the client, suggesting that it resize its surface to the provided size s. The edges provide a hint about how the surface was resized.

void sendPopupDone()

Sends a popup_done event to the client to indicate that the user has clicked somewhere outside the client's surfaces.